﻿/*************************************\
 *           Dateizugriffe           *
 *                                   *
 * Kapitel: Dateien und Streams      *
 * Zuordnung: C#-Buch V2.0 5.1       *
 *                                   *
 *  Copyright 2015 by Benjamin Jung  *
\*************************************/
using System;
using System.IO;

namespace CSV20.Dateizugriffe
{
    class Program
    {
        static void Main(string[] args)
        {
            const string sDateinameTest = "test.txt";
            const string sDateinameTestCopy = "test2.txt";
            const string sDateinameLog = "logfile.txt";

            string[] sDateiInhaltSchreiben = new string[] {
                "C#-Buch V 2.0",
                "",
                "Kapitel 5 (Dateien und Streams)",
                "Thema 1 (Dateizugriffe)"
            };
            string[] sDateiInhaltLesen;

            try
            {
                // Daten in Datei schreiben und danach lesen
                Console.WriteLine("Test-Datei wird geschrieben ..."); 
                File.WriteAllLines(sDateinameTest, sDateiInhaltSchreiben);
                Console.WriteLine("Test-Datei wurde geschrieben!"); 
                Console.WriteLine("Test-Datei wird gelesen ..."); 
                sDateiInhaltLesen = File.ReadAllLines(sDateinameTest);
                if (sDateiInhaltSchreiben.Length == sDateiInhaltLesen.Length)
                {
                    for (int i = 0; i < sDateiInhaltSchreiben.Length; i++)
                        if (sDateiInhaltSchreiben[i] != sDateiInhaltLesen[i])
                            Console.WriteLine("In Zeile {0} wurde ein Unterschied gefunden!", i);
                }
                else
                    Console.WriteLine("Die Länge des gelesenen und geschrieben Arrays stimmt nicht überein!");
                Console.WriteLine("Test-Datei wurde gelesen!");

                Console.WriteLine();

                // Logfile-Eintrag schreiben
                Console.WriteLine("Logfile wird geschrieben ...");
                File.AppendAllText(sDateinameLog, "Das Programm wurde erfolgreich ausgeführt!\r\n");    // \r\n ist der Zeilenumbruch für Windows
                Console.WriteLine("Logfile wurde geschrieben!");

                Console.WriteLine();

                Console.WriteLine("Führe Dateiaktionen aus ...");
                File.Copy(sDateinameTest, sDateinameTestCopy, true);    // true = überschreiben erlaubt
                File.Delete(sDateinameTest);
                File.Move(sDateinameTestCopy, sDateinameTest);
                if (!File.Exists(sDateinameTestCopy))                   // Bedingung sollte immer zutreffen
                    File.Create(sDateinameTestCopy);
                else
                    Console.WriteLine("Kopie der Test-Datei existiert bereits!");
                Console.WriteLine("Dateiaktionen wurden ausgeführt!");
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }

            Console.ReadKey();
        }
    }
}